require 'savon'
require 'active_support/core_ext'

User = 'INSERT HERE USER PROVIDED BY JUNIPER XML AGENTS'
Password = 'INSERT HERE PASS PROVIDED BY JUNIPER XML AGENTS'

AuxStartDate = Date.today + rand(4..6).months
AuxEndDate = AuxStartDate + rand(1..7).days

StartDate = AuxStartDate.strftime("%F")
EndDate = AuxEndDate.strftime("%F")

hotelAvailclient = Savon.client(
    wsdl: 'https://xml-uat.bookingengine.es/webservice/jp/webservicejp.asmx?wsdl', 
    endpoint: 'https://xml-uat.bookingengine.es/webservice/jp/operations/availtransactions.asmx',
    ssl_verify_mode: :none,
    log_level: :debug, 
    log: true, 
    pretty_print_xml: true,
    convert_request_keys_to: :none,
    headers: {
        "Content-Type" => "text/xml;charset=UTF-8",
        "SOAPAction" => '"http://www.juniper.es/webservice/2007/HotelAvail"'
    }
)


HotelCodesJP = {'HotelCode'=> ['JP046300','JP046391','JP150074']}

AdvancedOptions = {
    'ShowHotelInfo'=> "false",
    'ShowOnlyBestPriceCombination'=> "true",
    'TimeOut'=> "8000"
}

HotelAvailRQ = {  
    Login: '',:attributes! => {Login: {"Password" => Password, "Email" => User}},
    Paxes: {Pax: {Age:"30"},:attributes! => { Pax: {"IdPax" => "1"}}},
    HotelRequest: {
        SearchSegmentsHotels: {
            SearchSegmentHotels: '', 
            CountryOfResidence: "ES",
            HotelCodes: HotelCodesJP,
            :attributes! => { SearchSegmentHotels: {"Start" => StartDate, "End" => EndDate}}

        },
        RelPaxesDist: {
            RelPaxDist: {
                RelPaxes: {
                    RelPax:'',:attributes! => { RelPax: {"IdPax" => "1"}}
                }
            }
        }
    },
    AdvancedOptions: AdvancedOptions
}

hotelAvailclient.call(:hotel_avail, message: {
    HotelAvailRQ: HotelAvailRQ, 
    :attributes! => {
        HotelAvailRQ: {
            "Version" => "1.1",
            "Language" => "ES"
        }
    }
})